package com.bj.avenue.admin.controller;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.bj.avenue.admin.mapper.IrptDimWzdwMapper;
import com.bj.avenue.common.util.R;
import com.bj.avenue.request.IrptDimWzdwRequest;
import com.bj.avenue.response.*;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.*;
import java.util.stream.Collectors;

@RestController
@Slf4j
@RequestMapping("/irpt/dim/wzdw")
public class IrptDimWzdwController {

    @Autowired
    private IrptDimWzdwMapper irptDimWzdwMapper;

    /**
     * 登录
     *
     * @return 用户信息
     */
    @PostMapping("/page")
    public R page(@RequestBody IrptDimWzdwRequest irptDimWzdwRequest, Page page) {
        IPage<IrptDimWzdwResponse> list = irptDimWzdwMapper.selectIrptDimWzdw(page, irptDimWzdwRequest);
        return R.ok(list);
    }

    /**
     * 登录
     *
     * @return 用户信息
     */
    @PostMapping("/tableHeadList")
    public R tableHeadList(@RequestBody IrptDimWzdwRequest irptDimWzdwRequest) {
        List<IrptDimWzdwResponse> list = irptDimWzdwMapper.tableHeadList(irptDimWzdwRequest);
        return R.ok(list);
    }

    /**
     * 登录
     *
     * @return 用户信息
     */
    @PostMapping("/list")
    public R list(@RequestBody IrptDimWzdwRequest irptDimWzdwRequest) {
        List<IrkzqXxb1Response> list = irptDimWzdwMapper.selectIrkzqXxb(irptDimWzdwRequest);
        for (int i = 0; i < list.size(); i++) {
            IrkzqXxb1Response irkzqXxb1Response = list.get(i);

            Map<String, Long> resultMap = irkzqXxb1Response.getList3().stream()
                    .collect(Collectors.toMap(IrkzqXxb3Response::getDmUpcode2, IrkzqXxb3Response::getTolnum));

            irkzqXxb1Response.setMap(resultMap);
            irkzqXxb1Response.setTolNum(resultMap.values().stream().mapToLong(Long::longValue).sum());
            irkzqXxb1Response.setTolMoney(irkzqXxb1Response.getList3().stream().mapToDouble(IrkzqXxb3Response::getTolMoney).sum());
        }

        return R.ok(list);
    }
}
