package com.bj.avenue.admin.controller;

import cn.hutool.core.text.CharSequenceUtil;
import cn.hutool.core.util.ObjectUtil;
import com.bj.avenue.admin.dto.User;
import com.bj.avenue.admin.mapper.UserMapper;
import com.bj.avenue.common.util.R;
import com.bj.avenue.convert.LoginConvert;
import com.bj.avenue.request.LoginRequest;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.codec.digest.DigestUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

@RestController
@Slf4j
@RequestMapping("/user")
public class UserController {

    @Autowired
    private UserMapper userMapper;

    /**
     * 登录
     *
     * @return 用户信息
     */
    @PostMapping("/login")
    public R findHistoryOrder(@RequestBody LoginRequest loginRequest) {
        if (CharSequenceUtil.isBlank(loginRequest.getUserid())) {
            return R.failed("用户名不为空");
        }
        if (CharSequenceUtil.isBlank(loginRequest.getPassword())) {
            return R.failed("密码不为空");
        }
        User user1 = userMapper.selectUser(loginRequest);
        if (ObjectUtil.isNull(user1)) {
            return R.failed("用户不存在");
        }
        StringBuilder password = new StringBuilder();
        password.append("{").append(DigestUtils.md5Hex(loginRequest.getPassword())).append("}");
        if (user1.getPassword().equals(password.toString())) {
            user1.setPassword("");
            return R.ok(LoginConvert.userHandleLoginResponse(user1));
        } else {
            return R.failed("密码错误");
        }
    }


}
